zoukankan      html  css  js  c++  java
  • [LeetCode#244] Shortest Word Distance II

    Problem:

    This is a follow up of Shortest Word Distance. The only difference is now you are given the list of words and your method will be called repeatedly many times with different parameters. How would you optimize it?

    Design a class which receives a list of words in the constructor, and implements a method that takes two words word1 and word2 and return the shortest distance between these two words in the list.

    For example,
    Assume that words = ["practice", "makes", "perfect", "coding", "makes"].

    Given word1 = “coding”word2 = “practice”, return 3.
    Given word1 = "makes"word2 = "coding", return 1.

    Note:
    You may assume that word1 does not equal to word2, and word1 and word2 are both in the list.

    Analysis:

    This is an updated version of Shortest Word Distance.
    Since it would be called many times, we should not do the search in traditional O(n) way. 
    One apparent thing we should optimize is to reduce uncessary check and comparision. We should exclude the words that we are not care about.
    The instant idea is to use a hashmap.
    Key: the word;
    Value: a list of indexes associated with the word. 
    
    Through this way, we can get all information we want by retrieving the HashMap, and only use two realated list.
    ArrayList<Integer> list1 = map.get(word1);
    ArrayList<Integer> list2 = map.get(word2);
    
    Even though we narrow down the elements we need to search, there could be a efficiency pitfall if we fail to implement it rightly.
    
    Traditionally we would try to search the shortest distance through following way. 
    for (int i = 0; i < list1.length(); i++) {
        for (int j = 0; j < list2.length(); j++) {
            min = Math.min(min, Math.abs(j - i));
        }
    }
    Apparently, at the worst case, the time complexity is O(n^2), which is even worse than our previous solution.
    Why? Cause there are many uncessary comparisions.
    ---------------------------------------------------------------------------------------------------------------
    word 1: [1, 5, 8]
    word 2: [2, 10]
    Since we have already compared min with |2-1|, why we still need to compare |8-1|, since all elements after 2 must have larger distance than |2-1| (with 1 fixed). It seems I get used with "for-loop" method to scan lists, while ignoring we actually could also use "while-loop" over two lists.
    -------------------------------------------------------------------
    while (i < m && j < n) {
        min = Math.min(min, Math.abs(list1.get(i)-list2.get(j)));
        if (list1.get(i) < list2.get(j))
            i++;
        else
            j++;
        }
    }
    -------------------------------------------------------------------
    The reason we could see the example:
    word 1: [1, 5, 8]
    word 2: [2, 10]
    After we finished the scan: "1, 2",
    "1" is no longer could have combination "1, x (x > 2)" has shorter distance than "1, 2".

    Solution:

    public class WordDistance {
        HashMap<String, ArrayList<Integer>> map = new HashMap<String, ArrayList<Integer>> ();
        public WordDistance(String[] words) {
            for (int i = 0; i < words.length; i++) {
                String word = words[i];
                if (map.containsKey(word)) {
                    map.get(word).add(i);
                } else{
                    ArrayList<Integer> item = new ArrayList<Integer> ();
                    item.add(i);
                    map.put(word, item);
                }
            }
        }
    
        public int shortest(String word1, String word2) {
            ArrayList<Integer> list1 = map.get(word1);
            ArrayList<Integer> list2 = map.get(word2);
            int i = 0, j = 0;
            int min = Integer.MAX_VALUE;
            int m = list1.size();
            int n = list2.size();
            while (i < m && j < n) {
                min = Math.min(min, Math.abs(list1.get(i)-list2.get(j)));
                if (list1.get(i) < list2.get(j))
                    i++;
                else
                    j++;
            }
            return min;
        }
    }
  • 相关阅读:
    正则如何匹配div下的所有<li>标签?
    日历
    生成一定数量的不重复随机数
    PHP微信红包的算法实现探讨
    Flask 快速使用 —— (1)
    Django rest framework(8)---- 视图和渲染器
    Django 组件之 ----- content-type
    Django rest framework(7)----分页
    Django rest framework(6)----序列化(2)
    Django rest framework(5)----解析器
  • 原文地址:https://www.cnblogs.com/airwindow/p/4805950.html
Copyright © 2011-2022 走看看